
//*************************************************************************
//
// robovoice (attiny13)
//
// steffen wrote this stuff for mikrocontrollerspielwiese.de 
// 
// have fun!
//*************************************************************************

#include <avr/io.h>
#define F_CPU 1200000UL
#include <util/delay.h>


//globale Variablen
//t = Tonhhe, i = Tonlnge
int  i,e;
float t;

//*************************************************************************

void rueckwaertsfahren(void){		//rueckwaertsfahr_melodie
	
	t=0.4; i=250/t;					
	while (i){
		PORTB |= _BV(PB0);_delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
		i--;	
	}
	_delay_ms(255);_delay_ms(255);_delay_ms(255);	// zeit zwischen den tnen 

}

//*************************************************************************

void einschaltton(void){			//einschalt_melodie
	
		t=2; i=100/t;
		while(i){
			PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
			i--;
		}
	
		t=1.5; i=75/t;
		while(i){
			PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
			i--;
		}
	
		t=1; i=50/t;
		while(i){
			PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
			i--;
		}
	
		t=0.7; i=25/t;
		while(i){
			PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
			i--;
		}
	
		t=0.3; i=55/t;
		while(i){
			PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
			i--;
		}
	
}	
	
	
//*************************************************************************
	
void hindernis(void){		//hindernis_erkannt_melodie
		
	t=0.2; i=10/t;
	while(i){
		PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
		i--;
	}
	_delay_ms(100);
		
	t=0.4; i=10/t;
	while(i){
		PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
		i--;
	}
	_delay_ms(100);
		
	t=0.6; i=10/t;
	while(i){
		PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
		i--;
	}
	_delay_ms(100);
		
	t=0.8; i=10/t;
	while(i){
		PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
		i--;
	}
	_delay_ms(100);
		
	t=1;	i=10/t;
	while(i){
		PORTB |= _BV(PB0); _delay_ms(t); PORTB &= ~_BV(PB0);_delay_ms(t);
		i--;
	}
	_delay_ms(255);

	
}

//*************************************************************************

int main(void){
	
  	DDRB |= _BV(PB0);  // Lautsprecher
	DDRB = DDRB & ~_BV(PB2) & ~_BV(PB3) & ~_BV(PB4); 	//Eingnge
	PORTB = PORTB | _BV(PB2) | _BV(PB3) | _BV(PB4); 		//PULL UPs aktivieren
	

	
   	while (1) {
		
		if (bit_is_clear(PINB,2)) rueckwaertsfahren(); //rueckwaertsfahren();
		if (bit_is_clear(PINB,3)) hindernis(); //hindernis erkannt();
		if (bit_is_clear(PINB,4)) einschaltton(); //einschalten
	}
  

	return 0;
}

//*************************************************************************


